#include "list.h"

using namespace System;


namespace TechnoAP { namespace usbmca {

	namespace data
	{
		/// <summary>
		/// constractor
		/// </summary>
		list::list()
		{
			mqwAbs = 0ll;
			mnPHA = 0;
			mnCH = 0;
		}

		/// <summary>
		/// constractor, with adjusting
		/// </summary>
		list::list(array<Byte> ^abList)
		{
			Adjust(abList);
		}

		/// <summary>
		/// adjusting list data
		/// </summary>
		void list::Adjust(array<Byte> ^abListData)
		{
			array<Byte> ^abTemp = gcnew array<Byte>(sizeof(__int64));

			Array::Clear(abTemp, 0, abTemp->Length);
			Buffer::BlockCopy(abListData, 0, abTemp, 2, 6);
			__int64 tmp64bit = BitConverter::ToInt64(abTemp, 0);
			short tmp16bit = BitConverter::ToInt16(abListData, 6);

			tmp64bit = System::Net::IPAddress::HostToNetworkOrder(tmp64bit);
			tmp16bit = System::Net::IPAddress::HostToNetworkOrder(tmp16bit);

			mqwAbs = (__int64)(tmp64bit & 0x0ffffffffffffll);
			mnCH = (int)(((tmp16bit >> 14) & 0x03) + 1);
			mnPHA = (int)(tmp16bit & 0x3fff);
		}

		/// <summary>
		/// create list data (detail)
		/// </summary>
		list^ list::createList(array<Byte> ^abList)
		{
			return	(gcnew list(abList));
		}
	}
} }


