#pragma once

using namespace System;


namespace TechnoAP { namespace usbmca {
	
	using namespace TechnoAP::usbmca;

	namespace data
	{
		////Time conversion class/////
		/// <summary>
		/// Summary for list
		/// </summary>
		public ref class list
		{
		public:
			/// <summary>
			/// Summary for time
			/// </summary>
			ref class time
			{
			public:
				__int64 mqwTotalNanoseconds = 0;
				__int64 mqwSeconds = 0;
				int mnMilliseconds = 0;
				int mnMicroseconds = 0;
				int mnNanoseconds = 0;

				void Analyze(__int64 lngNanoseconds)
				{
					__int64 tmpTime = lngNanoseconds;

					mqwTotalNanoseconds = tmpTime;
					mnNanoseconds = (int)(tmpTime % 1000);
					tmpTime /= 1000;
					mnMicroseconds = (int)(tmpTime % 1000);
					tmpTime /= 1000;
					mnMilliseconds = (int)(tmpTime % 1000);
					tmpTime /= 1000;
					mqwSeconds = (__int64)(tmpTime);
					tmpTime /= 1000;
				}
			};

		public:
			__int64 mqwAbs = 0;		// absolute time
			int mnCH = 0;			// CH number
			int mnPHA = 0;			// pulse height analyzer

		public:
			list();
			list(array<Byte>^ abListData);

			void Adjust(array<Byte>^ abListData);
			static list^ createList(array<Byte>^ abListData);

		};
	}
} }



