#pragma once

#include "constant\constant.h"

using namespace System;


namespace TechnoAP { namespace usbmca {

	using namespace FTD2XX_NET;
	using namespace TechnoAP::usbmca;
	using namespace TechnoAP::usbmca;

	namespace device
	{
		/// <summary>
		/// Summary for status
		/// </summary>
		public ref class status
		{
		public:
			/// <summary>
			/// Summary for status_ch(CH unit) 
			/// </summary>
			ref class status_ch
			{
			public:
				__int64 mLiveTime = 0;
				__int64 mDeadTime = 0;
				unsigned int mThroughputRate = 0;
				unsigned int mThroughputCount = 0;
				unsigned int mInputRate = 0;
			};

		public:
			status();

		public:
			__int64 mRealTime;
			array<status_ch^> ^maChannel = gcnew array<status_ch^>(constant::Max::CH);

		public:
			status^ analyzeData(array<Byte> ^abStatus);
			__int64 getElapsedTimeMillisoconds(void);
			__int64 getElapsedTimeNanoseconds(void);

		};

	}
} }



